;@GOTO TRANSLATE


.586P   ;don't use .386(P) - it affects max section align

.MODEL             FLAT, STDCALL  ;flat model with STDCALL calling convention

   OPTION          CASEMAP: NONE  ;source is case sensitive

;----------------------------------------------------------------------------------
   INCLUDE         WINDOWS.inc    ;ML include file by Iczelion and hutch
;   UNICODE         = FALSE       ;defined on ML command line (/DUNICODE)
   INCLUDE         APIMACRO.mac
   INCLUDE         NTSTATUS.inc   ;always useful
;----------------------------------------------------------------------------------
; I will use 2 self made import libraries ..
   INCLUDELIB      iKERNEL32.lib
   INCLUDELIB      iUSER32.lib
; .. and 1 standard SDK import library
   INCLUDELIB      ADVAPI32.lib
; Because I'm using standard library I can't use eLINK (LINK 5.0), I must use
;LINK (6.00).
; Libraries created by LINK 5.12+ aren't compatible with 5.12- libraries.
; LINK 5.12+ can work with any library but LINK 5.12- can work only with 5.12-
;library.
; If I wouldn't use 5.12+ library I could use eLINK which doesn't create ugly
;"Rich" zone between DOS stub and PE header.

; LINK 6.0 creates files with align 4096, I'm decresing file size of ansi version
;(ExampleA.exe)with /filealign:512 switch.
; I'm creating unicode version (ExampleW.exe) with /align:16 switch. PE with
;such align can run in NT only. In this case smaller align doesn't decrease final
;file size.
;----------------------------------------------------------------------------------

;declare C symbol GetVersion
   iEXTERN  GetVersion
;now I can do anything with GetVersion variable (ADD, SUB, CMP, CALL, JMP, ...)
;no import macros are needed for manipulation with GetVersion now
;disadvantage is I can't declare or define variable with name GetVersion now
;for example I can't do:  TEXT GetVersion, <GetVersion/0>

;iEXTERN can be placed everywhere 
;----------------------------------------------------------------------------------

;begin .text section

.CODE

;define UNICODE dependent texts:

;place for GetUserName output (initialized with text)
   TEXT     UserNow, <Default/0                                            >
;now sUserNow == offset UserNow | LUserNow == size in characters

;place for GetComputerName output (initialized with text)
   TEXT     Machine, <Default/0                                            >
;now sMachine == offset Machine | LMachine == size in characters

;template for wsprintf
   TEXT     Template,  <Hi /#s on /#s/:/n/0>


;hooked _lread
 My_lread:
   JMP      Orig_lread

;program entry
 PrimaryThread:

;initialize (register0 variables
   oLEA     EBX, UserNow
   oLEA     ESI, Machine
   oLEA     EBP, Buffer
;save original _lread address
   iPUSH    _lread
   POP      Orig_lread
;hook _lread (.text is WRITABLE)
   iMOVw    _lread, My_lread

;turn into console application
   iWin32   AllocConsole

;demonstrate that anything is possible with GetVersion (declared via iEXTERN)
   PUSH     GetVersion
   CMP      GetVersion, 80000000H
;GetComputerName wasn't declared via iEXTERN -> I must use iMACROS
   iMOVi    ECX, GetComputerName
;demonstrate that anything is possible with GetVersion (declared via iEXTERN)
   ADD      ECX, GetVersion
   POP      GetVersion

   PUSH     LUserNow     ;make superlocal variable and initialize it with LUserNow
   iWin32@i GetUserName, EBX, ESP ;call GetUserNameX@8 from ADVAPI32.lib
   POP      EAX          ;read superlocal variable and delete it

   PUSHc    GoOnThere, STD_OUTPUT_HANDLE
   iWin32j  GetStdHandle
   JMP      $

  GoOnThere:
   MOV      EDI, EAX

   ;make superlocal variable and initialize it with LMachine
   ;and call GetComputerNameX
   ;I'm not limited by number of parameters (vs. INVOKE or iWin32@)
   ;(GetComputerName has 2 parameters)
   iWin32i  GetComputerName, ESI, ESP, LMachine
   POP      EAX          ;read superlocal variable and delete it

   ;call C function
   icWin32i wsprintf, EBP, sTemplate, EBX, ESI
   ;write output
   iWin32i  WriteConsole, EDI, EBP, EAX, ESP, NULL

   ;prepare stack for ExitProcess
   ExitCode = 1111
   PUSHc    0, ExitCode   ;0 - like EIP
   iPUSH    ExitProcess

   ;In NT I can terminate process with RET (if I've preserved stack = starting ESP)
   ;Termination via RET in 9x is possible but bad - DLLs get no PROCESS_DETACH
   ;So using ExitProcess is universal

   ;call _lwrite (always requires ansi string)
   PUSHc    OFFSET @F, STD_OUTPUT_HANDLE, sExitProcess, LExitProcess
   iPUSH    _lwrite
   RET

   ;here is the ansi string for _lwrite
   TEXTA    ExitProcess, <Farewell and Enter...>
   ;if ExitProcess would be declared via iEXTERN I couldn't use it

  @@:
   oMOV     EDI, STD_INPUT_HANDLE  ;optimized MOV
   ;wait for Enter...
   iWin32   FlushFileBuffers, EDI
   iWin32   _lread, EDI, ESP, 1   ;call hooked _lread

   RET ; do CALL ExitProcess, ExitCode


.DATA?
   Orig_lread DWORD ?  ;original address of _lread
   Buffer   SIGN  LUserNow+LMachine+LTemplate DUP (?) ;place for wsprintf
            ;size in bytes 

END  PrimaryThread

:TRANSLATE
@ECHO OFF
ML    /c /coff /nologo /DUNICODE example.bat
LINK  example /out:exampleA.exe /filealign:512 /IGNORE:4078,4060 /nologo /STUB:PEstub.exe /SUBSYSTEM:WINDOWS /optidata /SECTION:.text,EWR /MERGE:.rdata=.text /MERGE:.data=.text
ML    /c /coff /nologo /DUNICODE=1 example.bat
LINK  example /out:exampleW.exe /align:16 /IGNORE:4078,4060,4108 /nologo /STUB:PEstub.exe /SUBSYSTEM:WINDOWS /optidata /SECTION:.text,EWR  /MERGE:.rdata=.text
DEL   example.obj
PAUSE
CLS